Package oracle.jdbc

## Interface OracleArray

All Superinterfaces:
  `java.sql.Array`

All Known Implementing Classes:
  `ARRAY`

    public interface OracleArray
    extends java.sql.Array

This interface defines the Oracle extensions to the standard JDBC interface `Array`.

Generally any new code should avoid the direct use of the class `ARRAY`. For variable declarations use the interface `Array` or this interface as required. For creating a `OracleArray` use `OracleConnection.createOracleArray(java.lang.String, java.lang.Object)`.

Since:
  11.2.0.3.0

### Method Summary

All Methods Instance Methods Abstract Methods
`double[]` `getDoubleArray()` Oracle extension.
`double[]` `getDoubleArray​(long index, int count)` Oracle extension.
`float[]` `getFloatArray()` Oracle extension.
`float[]` `getFloatArray​(long index, int count)` Oracle extension.
`int[]` `getIntArray()` Oracle extension.
`int[]` `getIntArray​(long index, int count)` Oracle extension.
`java.util.Map<?,​?>` `getJavaMap()` Analogous to getArray except that it returns indices and elements of the SQL associative array as java.util.Map.
`long[]` `getLongArray()` Oracle extension.
`long[]` `getLongArray​(long index, int count)` Oracle extension.
`OracleTypeMetaData` `getOracleMetaData()` Oracle extension.
`short[]` `getShortArray()` Oracle extension.
`short[]` `getShortArray​(long index, int count)`
`java.lang.String` `getSQLTypeName()` Oracle extension.
`int` `length()` Oracle extension.
`java.lang.Object` `toJdbc()` Oracle extension.

### Methods inherited from interface java.sql.Array

`free, getArray, getArray, getArray, getArray, getBaseType, getBaseTypeName, getResultSet, getResultSet, getResultSet, getResultSet`

### Method Detail

#### getOracleMetaData

    OracleTypeMetaData getOracleMetaData()
                                  throws java.sql.SQLException

Oracle extension. Get the SQL ARRAY type metadata for the type of this object.

Returns:
  metadata for this object's type
Throws:
  `java.sql.SQLException` - if an error occurs

#### length

    int length()
        throws java.sql.SQLException

Oracle extension. Get array size.

Returns:
  the number of elements in the array.
Throws:
  `java.sql.SQLException`

#### getSQLTypeName

    java.lang.String getSQLTypeName()
                             throws java.sql.SQLException

Oracle extension. Retrieves the SQL type name of the SQL structured type that this `Struct` object represents.

Returns:
  the fully-qualified type name of the SQL collection type for which this `Array` object is the generic representation
Throws:
  `java.sql.SQLException` - if a database access error occurs

#### toJdbc

    java.lang.Object toJdbc()
                     throws java.sql.SQLException

Oracle extension. Returns the JDBC representation of the datum object

Returns:
  an object containing the JDBC value
Throws:
  `java.sql.SQLException` - if conversion to JDBC representation results in an error

#### getIntArray

    int[] getIntArray()
               throws java.sql.SQLException

Oracle extension. Analogous to getArray except that it always returns an int[].

Returns:
  an array of int.
Throws:
  `java.sql.SQLException`

#### getIntArray

    int[] getIntArray​(long index,
                      int count)
               throws java.sql.SQLException

Oracle extension. Like getIntArray, but returns a slice.

Parameters:
  `index` - the index of the first element to be returned
  `count` - the number of elements to be returned.
Returns:
  an array containing count elements starting at index
Throws:
  `java.sql.SQLException`

#### getDoubleArray

    double[] getDoubleArray()
                     throws java.sql.SQLException

Oracle extension. Analogous to getArray except that it always returns a double[].

Returns:
  an array of double.
Throws:
  `java.sql.SQLException`

#### getDoubleArray

    double[] getDoubleArray​(long index,
                            int count)
                     throws java.sql.SQLException

Oracle extension. Like getDoubleArray, but returns a slice.

Parameters:
  `index` - the index of the first element to be returned
  `count` - the number of elements to be returned.
Returns:
  an array containing count elements starting at index
Throws:
  `java.sql.SQLException`

#### getShortArray

    short[] getShortArray()
                   throws java.sql.SQLException

Oracle extension. Analogous to getArray except that it always returns a short[].

Returns:
  an array of short.
Throws:
  `java.sql.SQLException`

#### getShortArray

    short[] getShortArray​(long index,
                          int count)
                   throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### getLongArray

    long[] getLongArray()
                 throws java.sql.SQLException

Oracle extension. Analogous to getArray except that it always returns a long[].

Returns:
  an array of long.
Throws:
  `java.sql.SQLException`

#### getLongArray

    long[] getLongArray​(long index,
                        int count)
                 throws java.sql.SQLException

Oracle extension. Like getLongArray, but returns a slice.

Parameters:
  `index` - the index of the first element to be returned
  `count` - the number of elements to be returned.
Returns:
  an array containing count elements starting at index
Throws:
  `java.sql.SQLException`

#### getFloatArray

    float[] getFloatArray()
                   throws java.sql.SQLException

Oracle extension. Analogous to getArray except that it always returns a float[].

Returns:
  an array of float.
Throws:
  `java.sql.SQLException`

#### getFloatArray

    float[] getFloatArray​(long index,
                          int count)
                   throws java.sql.SQLException

Oracle extension. Like getFloatArray, but returns a slice.

Parameters:
  `index` - the index of the first element to be returned
  `count` - the number of elements to be returned.
Returns:
  an array containing count elements starting at index
Throws:
  `java.sql.SQLException`

#### getJavaMap

    java.util.Map<?,​?> getJavaMap()
                                 throws java.sql.SQLException

Analogous to getArray except that it returns indices and elements of the SQL associative array as java.util.Map. For non SQL associative array types (such as VARRAY or NESTED TABLE) this method returns null.

Returns:
  a Map containing indices and elements of the SQL associative array
Throws:
  `java.sql.SQLException`